import { _decorator, Component, math, Node, v3, Vec2, Vec3 } from 'cc';
import { Actor } from './Actor';
import { VirtualInput } from '../Input/VirtualInput';
import { StateDefine } from './StateDefine';
import { MathUtil } from '../Util/MathUtil';
import { TowardsDirection } from './TowardsDirection';
const { ccclass, property, requireComponent } = _decorator;
let toDirection = null;
@ccclass('PlayerController')
@requireComponent(Actor)
export class PlayerController extends Component {
    actor: Actor = null;
    start() {
        this.actor = this.node.getComponent(Actor);
    }
    update(deltaTime: number) {
        this.actor.input.x = VirtualInput.horizontal;
        this.actor.input.y = VirtualInput.vertical;
        if (this.actor.input.length() > 0) {
            if (this.actor.currentState != StateDefine.Run) {
                this.actor.changeState(StateDefine.Run);
            }
            //只有移动时需要改变方向
            this.changeDirection();
        } else {
            if (this.actor.currentState != StateDefine.Idle) {
                this.actor.changeState(StateDefine.Idle);
            }
        }
    }
    // 改变方向
    changeDirection(input: Vec2 = this.actor.input) {
        toDirection = MathUtil.judgeDirection(input);
        if(toDirection == this.actor.currentTowards){
            //如果方向没有变化，则不进行处理
            return;
        }else{
            //如果方向有变化，则改变方向并切换动画
            this.actor.setTowards(toDirection);
            this.actor.changeAnimation();
        }
    }

}


