import { _decorator, Camera, Component, Node, v3, Vec2, Vec3 } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('CameraController')
export class CameraController extends Component {
    @property
    OrthoHeight: number = 160;
    private camera: Camera = null;
    private player: Node = null;
    private playerPos: Vec3 = null;
    private cameraPos: Vec3 = null;
    private move: Vec3 = null;
    onLoad() {
        this.camera = this.node.getComponent(Camera);
        this.player = this.node.parent.getChildByName('player');
    }
    start() {
        this.cameraPos = v3(0, 0, 0);
        this.camera.orthoHeight = this.OrthoHeight;
    }

    lateUpdate(deltaTime: number) {
        this.playerPos = this.player.getPosition();
        if(this.playerPos==this.cameraPos){
            return;
        }
        this.move = v3(this.playerPos.x-this.cameraPos.x, this.playerPos.y-this.cameraPos.y,0)
        // if(this.move.length() > 0.5){
            this.cameraPos = this.playerPos;
            this.node.setPosition(this.playerPos);
        // }
    }
}


