import { _decorator, CCString, Component, Node, TiledLayer, TiledMap } from 'cc';
const { ccclass, property } = _decorator;
let _tilesets: any = null;
@ccclass('OutGameManager')
export class OutGameManager extends Component {
    @property(TiledMap)
    map: TiledMap = null;
    @property(CCString)
    path: string = '';
    onLoad() {
        _tilesets = this.map._tilesets;
    }
    start() {
        const tilesets = this.map._tilesets;
        const lastTileset = this.map._tilesets[this.map._tilesets.length-1];
        const firstGid = lastTileset.firstGid;
        //+2是因为拉伸1px,要保证最后一个图块集拉伸了一像素
        //获取tilecount的另一个办法是读取lastTileset文件，获取其中的tilecount
        const tilecount = (lastTileset.imageSize.width / (lastTileset._tileSize.width+2))*(lastTileset.imageSize.height / (lastTileset._tileSize.height+2));
        const mapTileCount = lastTileset.firstGid + tilecount - 1;
        console.log('mapTileCount:',mapTileCount);
        //输出每个拥有type属性的tile的gid
        for (let i = 0; i < mapTileCount; i++) {
            const property = this.map.getPropertiesForGID(i);
            if(property){
                if(property.type){
                    console.log(property.type+': '+i);
                }
            }
        }
    }

    update(deltaTime: number) {

    }
}


