//Grid与图块的关系
const TileGrid = {
    WaterSoil_LeftUp: 142,
    WaterSoil_Up: 143,            
    WaterSoil_RightUp: 144,
    WaterSoil_Left: 156,
    WaterSoil_Right: 158,
    WaterSoil_LeftDown: 170,
    WaterSoil_Down: 171,
    WaterSoil_RightDown: 172,
    SoilWater_LeftUp: 145,
    SoilWater_RightUp: 146,
    SoilWater_LeftDown: 159,
    SoilWater_RightDown: 160,
    GrassDown_LeftUp: 147,
    GrassDown_Up: 148,
    GrassDown_RightUp: 149,
    GrassDown_Left: 161,
    GrassDown_Right: 163,
    GrassDown_LeftDown: 175,
    GrassDown_Down: 176,
    GrassDown_RightDown: 177,
    GrassUP_LeftUp: 189,
    GrassUP_RightUp: 190,
    GrassUP_LeftDown: 203,
    GrassUP_RightDown: 204,

    Grass_Water_LeftUp: 153,
    Grass_Water_Up: 154,
    Grass_Water_RightUp: 155,
    Grass_Water_Left: 167,
    Grass_Water_Right: 169,
    Grass_Water_LeftDown: 181,
    Grass_Water_Down: 182,
    Grass_Water_RightDown: 183,
    Water_Grass_LeftUp: 195,
    Water_Grass_RightUp: 196,
    Water_Grass_LeftDown: 209,
    Water_Grass_RightDown: 210,
};
// 创建双向哈希表
const nameToValue = TileGrid;
const valueToName = Object.fromEntries(
    Object.entries(TileGrid).map(([key, value]) => [value, key])
);

// 导出双向哈希表
export const TileGridBidirectional = {
    nameToValue,
    valueToName
};


//碰撞的类型
export enum ColliderType {
    Down_LeftUp = 'Down_LeftUp',
    Down_Up = 'Down_Up',
    Down_RightUp = 'Down_RightUp',
    Down_Left = 'Down_Left',
    Down_Right = 'Down_Right',
    Down_LeftDown = 'Down_LeftDown',
    Down_Down = 'Down_Down',
    Down_RightDown = 'Down_RightDown',
    Up_LeftUp = 'Up_LeftUp',
    Up_RightUp = 'Up_RightUp',
    Up_LeftDown = 'Up_LeftDown',
    Up_RightDown = 'Up_RightDown',
}
//根据gird获取到碰撞类型
export const GridColliderMap = {
    "WaterSoil_LeftUp": ColliderType.Down_LeftUp,
    "WaterSoil_Up": ColliderType.Down_Up,
    "WaterSoil_RightUp": ColliderType.Down_RightUp,
    "WaterSoil_Left": ColliderType.Down_Left,
    "WaterSoil_Right": ColliderType.Down_Right,
    "WaterSoil_LeftDown": ColliderType.Down_LeftDown,
    "WaterSoil_Down": ColliderType.Down_Down,
    "WaterSoil_RightDown": ColliderType.Down_RightDown,
    "SoilWater_LeftUp": ColliderType.Up_LeftUp,
    "SoilWater_RightUp": ColliderType.Up_RightUp,
    "SoilWater_LeftDown": ColliderType.Up_LeftDown,
    "SoilWater_RightDown": ColliderType.Up_RightDown,
    "GrassDown_LeftUp": ColliderType.Down_LeftUp,
    "GrassDown_Up": ColliderType.Down_Up,
    "GrassDown_RightUp": ColliderType.Down_RightUp,
    "GrassDown_Left": ColliderType.Down_Left,
    "GrassDown_Right": ColliderType.Down_Right,
    "GrassDown_LeftDown": ColliderType.Down_LeftDown,
    "GrassDown_Down": ColliderType.Down_Down,
    "GrassDown_RightDown": ColliderType.Down_RightDown,
    "GrassUP_LeftUp": ColliderType.Up_LeftUp,
    "GrassUP_RightUp": ColliderType.Up_RightUp,
    "GrassUP_LeftDown": ColliderType.Up_LeftDown,
    "GrassUP_RightDown": ColliderType.Up_RightDown,
    "Grass_Water_LeftUp": ColliderType.Down_LeftUp,
    "Grass_Water_Up": ColliderType.Down_Up,
    "Grass_Water_RightUp": ColliderType.Down_RightUp,
    "Grass_Water_Left": ColliderType.Down_Left,
    "Grass_Water_Right": ColliderType.Down_Right,
    "Grass_Water_LeftDown": ColliderType.Down_LeftDown,
    "Grass_Water_Down": ColliderType.Down_Down,
    "Grass_Water_RightDown": ColliderType.Down_RightDown,
    "Water_Grass_LeftUp": ColliderType.Up_LeftUp,
    "Water_Grass_RightUp": ColliderType.Up_RightUp,
    "Water_Grass_LeftDown": ColliderType.Up_LeftDown,
    "Water_Grass_RightDown": ColliderType.Up_RightDown,
}