import { _decorator, Component, math, Node, v2, Vec2 } from 'cc';
import { TowardsDirection } from '../Actor/TowardsDirection';
const { ccclass, property } = _decorator;
const xAxis = v2(1, 0);
@ccclass('MathUtil')
export class MathUtil extends Component {
    static judgeDirection(vec:Vec2) {
        let angleInRadians = vec.angle(xAxis); // 计算与x轴正方向的夹角，结果以弧度表示
        let angleInDegrees = math.toDegree(angleInRadians); // 转换为度数
        if(angleInDegrees<=45){
            return TowardsDirection.Right;
        }else if(angleInDegrees>=135){
            return TowardsDirection.Left;
        }else if(vec.y>0){
            return TowardsDirection.Up;    
        }else{
            return TowardsDirection.Down;
        }
    }
}


